<!--
Use this article template as a quick starting point when writing Cosmos SDK conceptual tutorials. 

After you review the template, delete the comments and begin writing your outline or article. Examples of Markdown formatting syntax are provided at the bottom of this template.

As you write, refer to industry style and formatting guidelines. 

We admire and respect these resources:

- Google developer documentation [style guide](https://developers.google.com/style)
- Digital Ocean [do.co/style](https://do.co/style)

[Create an issue](https://github.com/cosmos/sdk-tutorials/issues) to let us know if you have questions. 

-->


# Understanding [Some Concept]

<!-- Use Title Case for all Titles, see https://capitalizemytitle.com/ -->

<!-- We like the way Digital Ocean explains things, you can learn about the title, introduction, and Goals sections at https://do.co/style#title-introduction-and-goals -->


### Introduction

<!-- Our articles have a consistent structure that includes an introduction, a conclusion, and any prerequisites necessary for a reader to get started. However, the specific structure depends on the type of article.
This template is to explain a concept. Conceptual articles can include, but do not require a prerequisites section, a Goals section, and might not follow the step convention.
-->

Introductory paragraph about the topic that explains what this topic is about and why the reader should care; what problem does it solve?

<!-- For example:
By integrating the Rosetta API in your Cosmos SDK blockchain application, exchanges are capable of listing your cryptocurrency coin.
-->

In this guide, you will [explore] [some thing]...
<!-- For example:
Add the RosettaCommand to your application root command file.
>
When you're finished, you'll be able to...
<!-- For example:
Run Rosetta in your application CLI.
>
## Requirements

<!-- Requirements let you leverage existing tutorials so you don't have to repeat core concepts, installation, or setup steps in your tutorial. 

The purpose is to spell out exactly what the reader should have or do before they follow the current tutorial. The format is a bulleted list that the reader can use as a checklist. Each bullet point must link to a specific page or existing tutorial that covers the necessary content if one exists. This allows you to rely on existing content known to work instead of starting from scratch.
 
Our tutorials take the reader from a fresh deployment to a working setup, so they should start from the beginning or include a prerequisite tutorial that does.

Common requirements for tutorials include:

Local software needed, such as Go and Starport. For example:
-->
- [Install Starport](../starport/index.md) v0.16.2 <!--(or whatever version applies)-->

## 

Introduction to the concept. What are we going to do and why are we doing it?

First....

Next...

Finally...


Now transition to the next section by telling the reader what's next.

## Another Section

Another introduction

Your content

Transition to the next section

## Conclusion

In this article you [explored/learned] [something]. Now you can....

<!-- Speak  to reader benefits of this technique or procedure and optionally provide places for further exploration. -->


<!------------ Formatting ------------------------->

<!-- Some examples of how to mark up various things

This is _italics_ and this is **bold**.

Only use italics and bold for specific things. 

This is `inline code`. Use it for referencing package names and commands.

Here's a command someone types on a command line:

```command
which go
```

Here's output from a command:

```
/usr/local/go/bin/go
```

Write key presses in ALLCAPS with in-line code formatting: `ENTER`.

Use a plus symbol (+) if keys need to be pressed simultaneously: `CTRL+C`.

<$>[note]
**Note:** This is a note.
<$>

<$>[warning]
**Warning:** This is a warning.
<$>

See [Notes, cautions, warnings, and other notices](https://developers.google.com/style/notices).

Add screenshots in PNG format with a self-describing filename. Embed them in the article using the following format:

![Alt text for screen readers](/path/to/img.png)

-->
